// version 3

#ifndef CLOCK_HPP
#define CLOCK_HPP

#include "Platform.hpp"
#include <string>

class Clock
{
#ifdef _WIN32
	u32 period;
#endif

public:
	Clock();
	~Clock();

	static u32 sec(); 		// timestamp in seconds
	static u32 hsec(); 		// timestamp in hundredths of a second
	static u32 msec(); 		// timestamp in milliseconds
	static double usec(); 	// timestamp in microseconds

	static std::string format(const char *format_string);

	static void sleep(u32 milliseconds);
};

#endif // include guard
