#include "Mutex.hpp"


Mutex::Mutex()
{
	InitializeCriticalSection(&cs);
}

Mutex::~Mutex()
{
	DeleteCriticalSection(&cs);
}

void Mutex::Enter()
{
	EnterCriticalSection(&cs);
}

void Mutex::Leave()
{
	LeaveCriticalSection(&cs);
}


AutoMutex::AutoMutex(Mutex &mutex)
{
	this->mutex = &mutex;
	mutex.Enter();
}

AutoMutex::~AutoMutex()
{
	Release();
}

void AutoMutex::Release()
{
	if (mutex)
	{
		mutex->Leave();
		mutex = 0;
	}
}
