// version 3

#ifndef SINGLETON_HPP
#define SINGLETON_HPP

#include "Platform.hpp"


#define SINGLETON(subclass) \
	private: \
		friend class Singleton<subclass>; \
		subclass()


template<class T> class Singleton
{
protected:
	Singleton<T>() {}
	Singleton<T>(Singleton<T> &) {}
	Singleton<T> &operator=(Singleton<T> &) {}

public:
	static T *ii;

public:
	inline static T *ref()
	{
		if (ii) return ii;
		return ii = new T;
	}
};

template<class T> T *Singleton<T>::ii = 0;

#endif // include guard
